package com.njyunzhi.yunshake.Controller;

import com.njyunzhi.yunshake.common.BaseController;
import com.njyunzhi.yunshake.common.ResponseBean;
import com.njyunzhi.yunshake.entity.TaScore;
import com.njyunzhi.yunshake.service.ITaScoreService;
import com.njyunzhi.yunshake.vo.TopScore;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 分数表 前端控制器
 * </p>
 *
 * @author lizhiwei
 * @since 2021-11-29
 */

@Api(tags = "分数表")
@RestController
@RequestMapping("/")
public class TaScoreController extends BaseController {

    private final Logger logger = LoggerFactory.getLogger(TaScoreController.class);

    @Autowired
    public ITaScoreService iTaScoreService;


//    /**
//     * 分页查询列表
//     * @param pageNum
//     * @param pageSize
//     * @return
//     */
//    @RequestMapping(value="/taScore",method= RequestMethod.GET)
//    @ApiOperation(value="列表", notes = "列表", httpMethod = "GET", response = ResponseBean.class)
//    public ResponseBean taScoreList(@ApiParam("页码") @RequestParam(value ="pageNum",defaultValue = "1") Integer pageNum,
//									 @ApiParam("单页数据量") @RequestParam(value ="pageSize",defaultValue = "10") Integer pageSize) throws Exception{
//
//		    IPage<TaScore> pg = new Page<>(pageNum, pageSize);
//            QueryWrapper<TaScore> queryWrapper = new QueryWrapper<>();
//            queryWrapper.orderByDesc("create_date");
//
//            IPage<TaScore> result = iTaScoreService.page(pg, queryWrapper);
//            return ResponseBean.success(result);
//    }

    /**
     * 高分榜
     *
     * @return
     */
    @RequestMapping(value = "/score/top", method = RequestMethod.GET)
    @ApiOperation(value = "高分榜", notes = "高分榜", httpMethod = "GET", response = ResponseBean.class)
    public ResponseBean getScoreTopList() throws Exception {
        List<TopScore> result = iTaScoreService.getScoreTopList(10);
        return ResponseBean.success(result);
    }


    /**
     * 保存对象
     *
     * @param taScore 实体对象
     * @return
     */
    @RequestMapping(value = "/ma/score", method = RequestMethod.POST)
    @ApiOperation(value = "摇一摇保存", notes = "摇一摇保存", httpMethod = "POST", response = ResponseBean.class)
    public ResponseBean taScoreAdd(@ApiParam("保存内容") @RequestBody TaScore taScore,
                                   HttpServletRequest request) throws Exception {

        taScore.setCreateDate(LocalDateTime.now());
        taScore.setPersonId(getCurrentPerson(request).getPersonId());

        if (iTaScoreService.save(taScore)) {
            return ResponseBean.success(taScore);
        } else {
            return ResponseBean.error("保存失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
        }
    }
//
//    /**
//     * 根据id删除对象
//     * @param id  实体ID
//     */
//    @RequestMapping(value="/taScore/{id}", method= RequestMethod.DELETE)
//    @ApiOperation(value="删除", notes = "删除", httpMethod = "DELETE", response = ResponseBean.class)
//    public ResponseBean taScoreDelete(@ApiParam("对象ID") @PathVariable Integer id) throws Exception{
//        if(iTaScoreService.removeById(id)){
//            return ResponseBean.success("success");
//        }else {
//            return ResponseBean.error("删除失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
//        }
//    }
//
//    /**
//     * 修改对象
//     * @param id  实体ID
//     * @param taScore 实体对象
//     * @return
//     */
//    @RequestMapping(value="/taScore/{id}",method= RequestMethod.PUT)
//    @ApiOperation(value="更新", notes = "更新", httpMethod = "PUT", response = ResponseBean.class)
//    public ResponseBean taScoreUpdate(@ApiParam("对象ID") @PathVariable Integer id,
//                                        @ApiParam("更新内容") @RequestBody TaScore taScore) throws Exception{
//
//        if (iTaScoreService.updateById(taScore)){
//            return ResponseBean.success(iTaScoreService.getById(id));
//        }else {
//            return ResponseBean.error("修改失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
//        }
//    }
//
//    /**
//     * 根据id查询对象
//     * @param id  实体ID
//     */
//    @RequestMapping(value="/taScore/{id}",method= RequestMethod.GET)
//    @ApiOperation(value="详情", notes = "详情", httpMethod = "GET", response = ResponseBean.class)
//    public ResponseBean taScoreGet(@ApiParam("对象ID") @PathVariable Integer id) throws Exception{
//        return ResponseBean.success(iTaScoreService.getById(id));
//    }
}
